var express = require('express');
var app = express();
var path = require('path');
var http = require('http').Server(app);
var io = require('socket.io')(http);
const electron = require('electron')

var eapp = electron.app
var BrowserWindow = electron.BrowserWindow


//app.use(express.static(__dirname)); // Current directory is root
express.static.mime.define({'text/css': ['css'],'text/javascript':['js']});
app.use(express.static(path.join(__dirname, 'static'))); //  "public" off of current is root
app.use('/vplace', express.static(__dirname + '/node_modules/vue/dist/'));
app.use('/splace', express.static(__dirname + '/node_modules/socket.io-client/dist/'));
app.use('/games', express.static(path.join(__dirname,"games")));

io.on('connection', function(socket){
  socket.emit("dirname",path.join(__dirname,"games"))
  socket.on('maximize', function(msg){
    if (win.isMaximized()) {
      win.unmaximize()
    }
    else {
      win.maximize();
    }
  });
  socket.on('minimize', function(msg){
    win.minimize();
  });
});


function getRandomInt(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min + 1)) + min;
}
right = false;
var port = 0;
while (right == false) {
  port = getRandomInt(1000,9000);
  try {
    http.listen(port);
    console.log('Listening on port '+port);
    right = true
  }
  catch (err) {
    pass
    print("Cannot use port "+port)
  }
}

let win

function createWindow () {
  // Create the browser window.
  win = new BrowserWindow({ width: 800, height: 600 ,frame:false, icon:path.join(__dirname,"static","assets","logo_small.png")})

  // and load the index.html of the app.
  win.loadURL('http://localhost:'+port+'/index.html')

  // Open the DevTools.
  

  // Emitted when the window is closed.
  win.on('closed', () => {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    win = null
  })
}

// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
eapp.on('ready', createWindow)

eapp.on("restore", function () {
  win.restore()
})

// Quit when all windows are closed.
eapp.on('window-all-closed', () => {
  // On macOS it is common for applications and their menu bar
  // to stay active until the user quits explicitly with Cmd + Q
  if (process.platform !== 'darwin') {
    eapp.quit()
  }
})

eapp.on('activate', () => {
  // On macOS it's common to re-create a window in the app when the
  // dock icon is clicked and there are no other windows open.
  if (win === null) {
    createWindow()
  }
})
