


Vue.component('f-header', {
  props:["seen","sidebar"],
  data: function () {
    return  {
      sideba:this.sidebar
    }
  },
  template: `<div class="header" >
    <div class="topbar" style="-webkit-user-select: none;-webkit-app-region: drag">
      <div>
        <img src="assets/logo_small.png"  class="topbar-img" />

      </div>
      <span class="title"><slot></slot></span><f-button v-if="seen" @click.native="sideit">☰</f-button>
      <f-button @click.native="min" style="-webkit-app-region: no-drag;">_</f-button>
      <f-button @click.native="maxi" style="-webkit-app-region: no-drag;">🗖</f-button>
      <f-button @click.native="close" style="-webkit-app-region: no-drag;">X</f-button>


    </div>
    <div class="topflop">

      <slot name="tabs"></slot>


    </div>
  </div>`,
  methods: {
    "sideit": function () {
      this.sideba = !this.sideba
      this.$emit('input',this.sideba)
    },
    "close": function () {
      window.close()
    },
    "maxi": function () {
      this.$root.maxi()
    },
    "min": function () {
      this.$root.min()
    }
    
  }
})

Vue.component('tab', {
  props: ['active',"href","method"],
  template: `<a :class="classes" :href="href" ><slot></slot></a>`,
  computed: {
    classes: function () {
      return {
        toolbutton:true,
        "toolbutton-active":this.active == true
      }
    }
  }
})

Vue.component('f-body', {
  template: `<div class="body"><slot></slot></div>`
})

Vue.component('f-container', {
  template: `<div class="f-list"><slot></slot></div>`
})


Vue.component('f-button', {

  template: `<button class="f-button"><slot></slot></button>`
})

Vue.component('f-list', {
  template: `<div class="f-list">
    <slot></slot>
  </div>`
})

Vue.component('f-list-button', {
  props: [],
  template: `<span class="f-list-button"><slot></slot></span>`
})

Vue.component('f-list-item', {
  template: `  <div class="f-list-item">
      <slot></slot>
    </div>`
})

Vue.component('f-sidebar', {
  props: ["seen"],
  template: `<div v-if="seen" class="f-sidebar" style="height:100%">

  <slot></slot>

  </div>`
})
Vue.component('f-sidebar-item', {
  template: `<div class="f-sidebar-item">
  <slot></slot>
  </div>`
})

Vue.component('f-footer', {
  template: `
    <div style="background: linear-gradient(rgba(10,10,10,0), #33CA2B);padding-top:40px;">
      <f-button @click.native="chtheme">Switch theme</f-button> <br><br />
      (c) Triangledot.
      <link rel="stylesheet" :href="rtheme" type="text/css" />
      <span style="display:none;">{{ ttheme }}</span>
    </div>
  `,
  data: function () {return {other:"lib/tri_dark.css",rtheme:"lib/tri.css"}},
  methods: {
    chtheme: function () {
      var t = JSON.parse(JSON.stringify(this.theme));
      //console.log(t);

      this.theme = this.other;
      //console.log(t)
      //this.other = t;
    }
  },
  computed: {
    ttheme: function () {
      themer = localStorage.getItem('TRI_theme')
      console.log(themer);
      if (!themer) {
        themer = "lib/tri.css";

      }
      if (themer == "lib/tri_dark.css") {
        this.other = "lib/tri.css"
      }
      this.theme = themer;
      return themer
    },
    theme: {
      get: function () {
        theme = localStorage.getItem('TRI_theme')
        console.log(theme);
        /*if (!theme) {
          theme = "lib/tri.css";

        }
        if (theme == "lib/tri_dark.css") {
          this.other = "lib/tri.css"
        }
        this.rtheme = theme;*/
        return theme
      },
      set: function(nval) {
        console.log(nval)
        theme = localStorage.setItem("TRI_theme",nval)
        this.rtheme = nval;
        if (nval == 'lib/tri_dark.css') {
          this.other = "lib/tri.css";
        }
        else {
          this.other = "lib/tri_dark.css";
        }
      }
    }
  }
})

Vue.component("f-v", {
  template: "<div class='f-h'><slot></slot></div>"
})

Vue.component("f-h", {
  template: "<div class='f-v'><slot></slot></div>"
})

Vue.component("f-input", {
  props:["value"],
  data: function () {
    return  {
      text:this.value
    }
  },
  watch:{
    value: function (newValue){
      this.text = newValue;
    }
  },
  template: `<input class="f-entry" type="text" v-model="text" @input="$emit('input',text)"/>`
})

Vue.component("f-progress", {
  props:["value"],
  
  template: `<div :style="{width:value+'%'}" class="f-progress"></div>`
})

Vue.component("f-text", {
  props:["value"],
  data: function () {
    return  {
      text:this.value
    }
  },
  watch:{
    value: function (newValue){
      this.text = newValue;
    }
  },
  template: `<textarea class="f-entry" type="text" v-model="text" @input="$emit('input',text)"/>`
})


Vue.component('f-checkbox', {
  model: {
    prop: 'checked',
    event: 'change'
  },
  props: {
    checked: Boolean
  },
  template: `
    <input
      class="f-checkbox"
      type="checkbox"
      v-bind:checked="checked"
      v-on:change="$emit('change', $event.target.checked)"
    >
  `
})
Vue.component("loading-symbol", {
  props: ["width", "height"],
  data: function () {return {polly:"polygon(5 5, 10 10, 0 0)"}},
  template:`<div class="loading-container" v-bind:style='{width:width,height:height}'><div class="loading"></div></div>`
})
